Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkStructuredGrid Class Reference

`#include <vtkStructuredGrid.h>`

Inheritance diagram for vtkStructuredGrid:

[legend]
Collaboration diagram for vtkStructuredGrid:

[legend]
List of all members.

## Detailed Description

topologically regular array of data

Date:
  2003/01/15 21:54:26

Revision:
  1.94

vtkStructuredGrid is a data object that is a concrete implementation of vtkDataSet. vtkStructuredGrid represents a geometric structure that is a topologically regular array of points. The topology is that of a cube that has been subdivided into a regular array of smaller cubes. Each point/cell can be addressed with i-j-k indices. Examples include finite difference grids.

The order and number of points must match that specified by the dimensions of the grid. The point order increases in i fastest (from 0<=i<dims[0]), then j (0<=j<dims[1]), then k (0<=k<dims[2]) where dims[] are the dimensions of the grid in the i-j-k topological directions. The number of points is dims[0]*dims[1]*dims[2]. The same is true for the cells of the grid. The order and number of cells must match that specified by the dimensions of the grid. The cell order increases in i fastest (from 0<=i<(dims[0]-1)), then j (0<=j<(dims[1]-1)), then k (0<=k<(dims[2]-1)) The number of cells is (dims[0]-1)*(dims[1]-1)*(dims[2]-1).

A unusual feature of vtkStructuredGrid is the ability to blank, or "turn-off" points and cells in the dataset. This is controlled by defining a "blanking array" whose values (0,1) specify whether a point should be blanked or not.

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (44%)
  - Law, Charles (27%)
  - Miller, Jim (6%)
  - Geveci, Berk (6%)

CVS logs (CVSweb):
  - .`h` (`/Common/vtkStructuredGrid.h)`
  - .`cxx` (`/Common/vtkStructuredGrid.cxx)`

Examples:
  vtkStructuredGrid (Examples)

Tests:
  vtkStructuredGrid (Tests)

Definition at line 78 of file vtkStructuredGrid.h.

## Public Types
typedef vtkPointSet | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
int | GetDataObjectType ()
void | CopyStructure (vtkDataSet *ds)
int | GetDataDimension ()
void | SetPointVisibility (vtkUnsignedCharArray *pointVisibility)
unsigned char | IsCellVisible (vtkIdType cellId)
unsigned long | GetActualMemorySize ()
virtual void | UpdateData ()
vtkIdType | GetNumberOfPoints ()
float * | GetPoint (vtkIdType ptId)
void | GetPoint (vtkIdType ptId, float p[3])
vtkCell * | GetCell (vtkIdType cellId)
void | GetCell (vtkIdType cellId, vtkGenericCell *cell)
void | GetCellBounds (vtkIdType cellId, float bounds[6])
int | GetCellType (vtkIdType cellId)
vtkIdType | GetNumberOfCells ()
void | GetCellPoints (vtkIdType cellId, vtkIdList *ptIds)
void | GetPointCells (vtkIdType ptId, vtkIdList *cellIds)
void | Initialize ()
int | GetMaxCellSize ()
void | GetCellNeighbors (vtkIdType cellId, vtkIdList *ptIds, vtkIdList *cellIds)
virtual void | GetScalarRange (float range[2])
float * | GetScalarRange ()
void | SetDimensions (int i, int j, int k)
void | SetDimensions (int dim[3])
virtual int * | GetDimensions ()
virtual void | GetDimensions (int dim[3])
void | SetBlanking (int blanking)
int | GetBlanking ()
void | BlankingOn ()
void | BlankingOff ()
void | BlankPoint (vtkIdType ptId)
void | UnBlankPoint (vtkIdType ptId)
vtkUnsignedCharArray * | GetPointVisibility ()
unsigned char | IsPointVisible (vtkIdType ptId)
void | SetUpdateExtent (int piece, int numPieces, int ghostLevel)
void | SetUpdateExtent (int piece, int numPieces)
void | SetUpdateExtent (int x1, int x2, int y1, int y2, int z1, int z2)
void | SetUpdateExtent (int ext[6])
void | SetExtent (int extent[6])
void | SetExtent (int x1, int x2, int y1, int y2, int z1, int z2)
virtual int * | GetExtent ()
virtual void | GetExtent (int &, int &, int &, int &, int &, int &)
virtual void | GetExtent (int[6])
void | ShallowCopy (vtkDataObject *src)
void | DeepCopy (vtkDataObject *src)
## Static Public Methods
vtkStructuredGrid * | New ()
int | IsTypeOf (const char *type)
vtkStructuredGrid * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkStructuredGrid ()
| ~vtkStructuredGrid ()
int | GetExtentType ()
virtual void | Crop ()
void | AllocatePointVisibility ()
## Protected Attributes
vtkVertex * | Vertex
vtkLine * | Line
vtkQuad * | Quad
vtkHexahedron * | Hexahedron
vtkEmptyCell * | EmptyCell
int | Dimensions [3]
int | DataDescription
int | Blanking
vtkUnsignedCharArray * | PointVisibility

## Member Typedef Documentation

typedef vtkPointSet vtkStructuredGrid::Superclass

| Reimplemented from vtkPointSet. Definition at line 83 of file vtkStructuredGrid.h.

## Constructor & Destructor Documentation

vtkStructuredGrid::vtkStructuredGrid | ( |  | ) | `[protected]`

vtkStructuredGrid::~vtkStructuredGrid | ( |  | ) | `[protected]`

## Member Function Documentation

vtkStructuredGrid* vtkStructuredGrid::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkDataObject.

virtual const char* vtkStructuredGrid::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkPointSet.

int vtkStructuredGrid::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPointSet.

virtual int vtkStructuredGrid::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPointSet.

vtkStructuredGrid* vtkStructuredGrid::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkPointSet.

void vtkStructuredGrid::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkPointSet.

int vtkStructuredGrid::GetDataObjectType | ( |  | ) | `[inline, virtual]`

| Return what type of dataset this is. Reimplemented from vtkDataSet. Definition at line 87 of file vtkStructuredGrid.h. References VTK_STRUCTURED_GRID.

void vtkStructuredGrid::CopyStructure | ( | vtkDataSet * | ds | ) | `[virtual]`

| Copy the geometric and topological structure of an input poly data object. Reimplemented from vtkPointSet.

vtkIdType vtkStructuredGrid::GetNumberOfPoints | ( |  | ) | `[inline, virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Reimplemented from vtkPointSet. Definition at line 95 of file vtkStructuredGrid.h. References vtkPointSet::GetNumberOfPoints(), and vtkIdType.

float* vtkStructuredGrid::GetPoint | ( | vtkIdType | ptId | ) | `[inline, virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Reimplemented from vtkPointSet. Definition at line 96 of file vtkStructuredGrid.h. References vtkPointSet::GetPoint(), and vtkIdType.

void vtkStructuredGrid::GetPoint | ( | vtkIdType | ptId,
|  | float | p[3]
| ) | `[inline, virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Reimplemented from vtkPointSet. Definition at line 97 of file vtkStructuredGrid.h. References vtkPointSet::GetPoint(), and vtkIdType.

vtkCell* vtkStructuredGrid::GetCell | ( | vtkIdType | cellId | ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet.

void vtkStructuredGrid::GetCell | ( | vtkIdType | cellId,
|  | vtkGenericCell * | cell
| ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet.

void vtkStructuredGrid::GetCellBounds | ( | vtkIdType | cellId,
|  | float | bounds[6]
| ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Reimplemented from vtkDataSet.

int vtkStructuredGrid::GetCellType | ( | vtkIdType | cellId | ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet.

vtkIdType vtkStructuredGrid::GetNumberOfCells | ( |  | ) | `[inline, virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet. Definition at line 249 of file vtkStructuredGrid.h. References GetDimensions(), and vtkIdType.

void vtkStructuredGrid::GetCellPoints | ( | vtkIdType | cellId,
|  | vtkIdList * | ptIds
| ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet.

void vtkStructuredGrid::GetPointCells | ( | vtkIdType | ptId,
|  | vtkIdList * | cellIds
| ) | `[inline, virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet. Definition at line 105 of file vtkStructuredGrid.h. References vtkStructuredData::GetPointCells(), and vtkIdType.

void vtkStructuredGrid::Initialize | ( |  | ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Reimplemented from vtkPointSet.

int vtkStructuredGrid::GetMaxCellSize | ( |  | ) | `[inline, virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet. Definition at line 110 of file vtkStructuredGrid.h.

void vtkStructuredGrid::GetCellNeighbors | ( | vtkIdType | cellId,
|  | vtkIdList * | ptIds,
|  | vtkIdList * | cellIds
| ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Reimplemented from vtkDataSet.

virtual void vtkStructuredGrid::GetScalarRange | ( | float | range[2] | ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Reimplemented from vtkDataSet.

float* vtkStructuredGrid::GetScalarRange | ( |  | ) | `[inline]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Reimplemented from vtkDataSet. Definition at line 114 of file vtkStructuredGrid.h. References vtkDataSet::GetScalarRange().

void vtkStructuredGrid::SetDimensions | ( | int | i,
|  | int | j,
|  | int | k
| ) |

| following methods are specific to structured grid

void vtkStructuredGrid::SetDimensions | ( | int | dim[3] | ) |

| following methods are specific to structured grid

virtual int* vtkStructuredGrid::GetDimensions | ( |  | ) | `[virtual]`

| Get dimensions of this structured points dataset. Referenced by GetNumberOfCells().

virtual void vtkStructuredGrid::GetDimensions | ( | int | dim[3] | ) | `[virtual]`

| Get dimensions of this structured points dataset.

int vtkStructuredGrid::GetDataDimension | ( |  | ) | `[inline]`

| Return the dimensionality of the data. Definition at line 271 of file vtkStructuredGrid.h. References vtkStructuredData::GetDataDimension().

void vtkStructuredGrid::SetBlanking | ( | int | blanking | ) |

| Methods for supporting blanking of cells. Blanking turns on or off points in the structured grid, and hence the cells connected to them.

int vtkStructuredGrid::GetBlanking | ( |  | ) | `[inline]`

| Methods for supporting blanking of cells. Blanking turns on or off points in the structured grid, and hence the cells connected to them. Definition at line 136 of file vtkStructuredGrid.h.

void vtkStructuredGrid::BlankingOn | ( |  | ) |

| Methods for supporting blanking of cells. Blanking turns on or off points in the structured grid, and hence the cells connected to them.

void vtkStructuredGrid::BlankingOff | ( |  | ) |

| Methods for supporting blanking of cells. Blanking turns on or off points in the structured grid, and hence the cells connected to them.

void vtkStructuredGrid::BlankPoint | ( | vtkIdType | ptId | ) |

| Methods for supporting blanking of cells. Blanking turns on or off points in the structured grid, and hence the cells connected to them.

void vtkStructuredGrid::UnBlankPoint | ( | vtkIdType | ptId | ) |

| Methods for supporting blanking of cells. Blanking turns on or off points in the structured grid, and hence the cells connected to them.

vtkUnsignedCharArray* vtkStructuredGrid::GetPointVisibility | ( |  | ) | `[inline]`

| Get the array that defines the blanking (visibility) of each point. Definition at line 145 of file vtkStructuredGrid.h.

void vtkStructuredGrid::SetPointVisibility | ( | vtkUnsignedCharArray * | pointVisibility | ) |

| Set an array that defines the (blanking) visibility of the points in the grid. Make sure that length of the visibility array matches the number of points in the grid.

unsigned char vtkStructuredGrid::IsPointVisible | ( | vtkIdType | ptId | ) | `[inline]`

| Return non-zero value if specified point is visible. Use this method only if blanking has been enabled (with BlankingOn()). Definition at line 157 of file vtkStructuredGrid.h. References vtkIdType.

unsigned char vtkStructuredGrid::IsCellVisible | ( | vtkIdType | cellId | ) |

| Return non-zero value if specified point is visible. Use this method only if blanking has been enabled (with BlankingOn()).

void vtkStructuredGrid::SetUpdateExtent | ( | int | piece,
|  | int | numPieces,
|  | int | ghostLevel
| ) |

| Required for the lowest common denominator for setting the UpdateExtent (i.e. vtkDataSetToStructuredPointsFilter). This assumes that WholeExtent is valid (UpdateInformation has been called).

void vtkStructuredGrid::SetUpdateExtent | ( | int | piece,
|  | int | numPieces
| ) | `[inline]`

| Required for the lowest common denominator for setting the UpdateExtent (i.e. vtkDataSetToStructuredPointsFilter). This assumes that WholeExtent is valid (UpdateInformation has been called). Reimplemented from vtkDataObject. Definition at line 170 of file vtkStructuredGrid.h. References vtkDataObject::SetUpdateExtent().

void vtkStructuredGrid::SetUpdateExtent | ( | int | x1,
|  | int | x2,
|  | int | y1,
|  | int | y2,
|  | int | z1,
|  | int | z2
| ) | `[inline, virtual]`

| Call superclass method to avoid hiding Reimplemented from vtkDataObject. Definition at line 176 of file vtkStructuredGrid.h. References vtkDataObject::SetUpdateExtent().

void vtkStructuredGrid::SetUpdateExtent | ( | int | ext[6] | ) | `[inline, virtual]`

| Call superclass method to avoid hiding Reimplemented from vtkDataObject. Definition at line 178 of file vtkStructuredGrid.h. References vtkDataObject::SetUpdateExtent().

void vtkStructuredGrid::SetExtent | ( | int | extent[6] | ) |

| Different ways to set the extent of the data array. The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

void vtkStructuredGrid::SetExtent | ( | int | x1,
|  | int | x2,
|  | int | y1,
|  | int | y2,
|  | int | z1,
|  | int | z2
| ) |

| Different ways to set the extent of the data array. The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

virtual int* vtkStructuredGrid::GetExtent | ( |  | ) | `[virtual]`

| Different ways to set the extent of the data array. The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

virtual void vtkStructuredGrid::GetExtent | ( | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & |
| ) | `[virtual]`

| Different ways to set the extent of the data array. The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

virtual void vtkStructuredGrid::GetExtent | ( | int | [6] | ) | `[virtual]`

| Different ways to set the extent of the data array. The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

unsigned long vtkStructuredGrid::GetActualMemorySize | ( |  | ) | `[virtual]`

| Return the actual size of the data in kilobytes. This number is valid only after the pipeline has updated. The memory size returned is guaranteed to be greater than or equal to the memory required to represent the data (e.g., extra space in arrays, etc. are not included in the return value). THIS METHOD IS THREAD SAFE. Reimplemented from vtkPointSet.

void vtkStructuredGrid::ShallowCopy | ( | vtkDataObject * | src | ) | `[virtual]`

| Shallow and Deep copy. Reimplemented from vtkPointSet.

void vtkStructuredGrid::DeepCopy | ( | vtkDataObject * | src | ) | `[virtual]`

| Shallow and Deep copy. Reimplemented from vtkPointSet.

virtual void vtkStructuredGrid::UpdateData | ( |  | ) | `[virtual]`

| This method calls the superclass then generates ghost levels if necessary. Reimplemented from vtkDataObject.

int vtkStructuredGrid::GetExtentType | ( |  | ) | `[inline, protected, virtual]`

| Reimplemented from vtkDataObject. Definition at line 220 of file vtkStructuredGrid.h. References VTK_3D_EXTENT.

virtual void vtkStructuredGrid::Crop | ( |  | ) | `[protected, virtual]`

| Reallocates and copies to set the Extent to the UpdateExtent. This is used internally when the exact extent is requested, and the source generated more than the update extent. Reimplemented from vtkDataObject.

void vtkStructuredGrid::AllocatePointVisibility | ( |  | ) | `[protected]`

## Member Data Documentation

vtkVertex* vtkStructuredGrid::Vertex`[protected]`

| Definition at line 213 of file vtkStructuredGrid.h.

vtkLine* vtkStructuredGrid::Line`[protected]`

| Definition at line 214 of file vtkStructuredGrid.h.

vtkQuad* vtkStructuredGrid::Quad`[protected]`

| Definition at line 215 of file vtkStructuredGrid.h.

vtkHexahedron* vtkStructuredGrid::Hexahedron`[protected]`

| Definition at line 216 of file vtkStructuredGrid.h.

vtkEmptyCell* vtkStructuredGrid::EmptyCell`[protected]`

| Definition at line 217 of file vtkStructuredGrid.h.

int vtkStructuredGrid::Dimensions[3]`[protected]`

| Definition at line 227 of file vtkStructuredGrid.h.

int vtkStructuredGrid::DataDescription`[protected]`

| Definition at line 228 of file vtkStructuredGrid.h.

int vtkStructuredGrid::Blanking`[protected]`

| Definition at line 229 of file vtkStructuredGrid.h.

vtkUnsignedCharArray* vtkStructuredGrid::PointVisibility`[protected]`

| Definition at line 230 of file vtkStructuredGrid.h.

The documentation for this class was generated from the following file:

- Common/vtkStructuredGrid.h